//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, v2.3.2 
// See <a href="https://javaee.github.io/jaxb-v2/">https://javaee.github.io/jaxb-v2/</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2020.02.07 at 08:51:11 PM CET 
//


package org.tdwg.abcd3.zoology;

import java.util.ArrayList;
import java.util.List;
import jakarta.xml.bind.annotation.XmlAccessType;
import jakarta.xml.bind.annotation.XmlAccessorType;
import jakarta.xml.bind.annotation.XmlElement;
import jakarta.xml.bind.annotation.XmlSchemaType;
import jakarta.xml.bind.annotation.XmlType;
import jakarta.xml.bind.annotation.adapters.NormalizedStringAdapter;
import jakarta.xml.bind.annotation.adapters.XmlJavaTypeAdapter;


/**
 * The application of a name (or concept), i.e. the data pertaining to an identification event and the result of the identification itself.
 * 
 * <p>Java class for Identification complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="Identification"&gt;
 *   &lt;complexContent&gt;
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *       &lt;sequence&gt;
 *         &lt;element name="PreferredFlag" type="{http://www.w3.org/2001/XMLSchema}boolean" minOccurs="0"/&gt;
 *         &lt;element name="HigherTaxa" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;complexContent&gt;
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *                 &lt;sequence&gt;
 *                   &lt;element name="HigherTaxon" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}HigherTaxon" maxOccurs="unbounded"/&gt;
 *                 &lt;/sequence&gt;
 *               &lt;/restriction&gt;
 *             &lt;/complexContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *         &lt;element name="FullScientificName" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String"/&gt;
 *         &lt;element name="References" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;complexContent&gt;
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *                 &lt;sequence&gt;
 *                   &lt;element name="Reference" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}Reference" maxOccurs="unbounded" minOccurs="0"/&gt;
 *                 &lt;/sequence&gt;
 *               &lt;/restriction&gt;
 *             &lt;/complexContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *         &lt;element name="Sex" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}SexCodeEnum" minOccurs="0"/&gt;
 *         &lt;element name="Age" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String" minOccurs="0"/&gt;
 *         &lt;element name="Notes" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}StringL" minOccurs="0"/&gt;
 *         &lt;element name="PhaseOrStage" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}StringL" maxOccurs="unbounded"/&gt;
 *         &lt;element name="Date" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}DateTime" minOccurs="0"/&gt;
 *         &lt;element name="Identifiers" minOccurs="0"&gt;
 *           &lt;complexType&gt;
 *             &lt;complexContent&gt;
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
 *                 &lt;sequence&gt;
 *                   &lt;element name="Identifier" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String255" maxOccurs="unbounded"/&gt;
 *                 &lt;/sequence&gt;
 *               &lt;/restriction&gt;
 *             &lt;/complexContent&gt;
 *           &lt;/complexType&gt;
 *         &lt;/element&gt;
 *       &lt;/sequence&gt;
 *     &lt;/restriction&gt;
 *   &lt;/complexContent&gt;
 * &lt;/complexType&gt;
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "Identification", propOrder = {
    "preferredFlag",
    "higherTaxa",
    "fullScientificName",
    "references",
    "sex",
    "age",
    "notes",
    "phaseOrStage",
    "date",
    "identifiers"
})
public class Identification {

    @XmlElement(name = "PreferredFlag")
    protected Boolean preferredFlag;
    @XmlElement(name = "HigherTaxa")
    protected Identification.HigherTaxa higherTaxa;
    @XmlElement(name = "FullScientificName", required = true)
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String fullScientificName;
    @XmlElement(name = "References")
    protected Identification.References references;
    @XmlElement(name = "Sex")
    @XmlSchemaType(name = "Name")
    protected SexCodeEnum sex;
    @XmlElement(name = "Age")
    @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
    @XmlSchemaType(name = "normalizedString")
    protected String age;
    @XmlElement(name = "Notes")
    protected StringL notes;
    @XmlElement(name = "PhaseOrStage", required = true)
    protected List<StringL> phaseOrStage;
    @XmlElement(name = "Date")
    protected DateTime date;
    @XmlElement(name = "Identifiers")
    protected Identification.Identifiers identifiers;

    /**
     * Gets the value of the preferredFlag property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public Boolean isPreferredFlag() {
        return preferredFlag;
    }

    /**
     * Sets the value of the preferredFlag property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setPreferredFlag(Boolean value) {
        this.preferredFlag = value;
    }

    /**
     * Gets the value of the higherTaxa property.
     * 
     * @return
     *     possible object is
     *     {@link Identification.HigherTaxa }
     *     
     */
    public Identification.HigherTaxa getHigherTaxa() {
        return higherTaxa;
    }

    /**
     * Sets the value of the higherTaxa property.
     * 
     * @param value
     *     allowed object is
     *     {@link Identification.HigherTaxa }
     *     
     */
    public void setHigherTaxa(Identification.HigherTaxa value) {
        this.higherTaxa = value;
    }

    /**
     * Gets the value of the fullScientificName property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getFullScientificName() {
        return fullScientificName;
    }

    /**
     * Sets the value of the fullScientificName property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setFullScientificName(String value) {
        this.fullScientificName = value;
    }

    /**
     * Gets the value of the references property.
     * 
     * @return
     *     possible object is
     *     {@link Identification.References }
     *     
     */
    public Identification.References getReferences() {
        return references;
    }

    /**
     * Sets the value of the references property.
     * 
     * @param value
     *     allowed object is
     *     {@link Identification.References }
     *     
     */
    public void setReferences(Identification.References value) {
        this.references = value;
    }

    /**
     * Gets the value of the sex property.
     * 
     * @return
     *     possible object is
     *     {@link SexCodeEnum }
     *     
     */
    public SexCodeEnum getSex() {
        return sex;
    }

    /**
     * Sets the value of the sex property.
     * 
     * @param value
     *     allowed object is
     *     {@link SexCodeEnum }
     *     
     */
    public void setSex(SexCodeEnum value) {
        this.sex = value;
    }

    /**
     * Gets the value of the age property.
     * 
     * @return
     *     possible object is
     *     {@link String }
     *     
     */
    public String getAge() {
        return age;
    }

    /**
     * Sets the value of the age property.
     * 
     * @param value
     *     allowed object is
     *     {@link String }
     *     
     */
    public void setAge(String value) {
        this.age = value;
    }

    /**
     * Gets the value of the notes property.
     * 
     * @return
     *     possible object is
     *     {@link StringL }
     *     
     */
    public StringL getNotes() {
        return notes;
    }

    /**
     * Sets the value of the notes property.
     * 
     * @param value
     *     allowed object is
     *     {@link StringL }
     *     
     */
    public void setNotes(StringL value) {
        this.notes = value;
    }

    /**
     * Gets the value of the phaseOrStage property.
     * 
     * <p>
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the JAXB object.
     * This is why there is not a <CODE>set</CODE> method for the phaseOrStage property.
     * 
     * <p>
     * For example, to add a new item, do as follows:
     * <pre>
     *    getPhaseOrStage().add(newItem);
     * </pre>
     * 
     * 
     * <p>
     * Objects of the following type(s) are allowed in the list
     * {@link StringL }
     * 
     * 
     */
    public List<StringL> getPhaseOrStage() {
        if (phaseOrStage == null) {
            phaseOrStage = new ArrayList<StringL>();
        }
        return this.phaseOrStage;
    }

    /**
     * Gets the value of the date property.
     * 
     * @return
     *     possible object is
     *     {@link DateTime }
     *     
     */
    public DateTime getDate() {
        return date;
    }

    /**
     * Sets the value of the date property.
     * 
     * @param value
     *     allowed object is
     *     {@link DateTime }
     *     
     */
    public void setDate(DateTime value) {
        this.date = value;
    }

    /**
     * Gets the value of the identifiers property.
     * 
     * @return
     *     possible object is
     *     {@link Identification.Identifiers }
     *     
     */
    public Identification.Identifiers getIdentifiers() {
        return identifiers;
    }

    /**
     * Sets the value of the identifiers property.
     * 
     * @param value
     *     allowed object is
     *     {@link Identification.Identifiers }
     *     
     */
    public void setIdentifiers(Identification.Identifiers value) {
        this.identifiers = value;
    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;element name="HigherTaxon" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}HigherTaxon" maxOccurs="unbounded"/&gt;
     *       &lt;/sequence&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "higherTaxon"
    })
    public static class HigherTaxa {

        @XmlElement(name = "HigherTaxon", required = true)
        protected List<HigherTaxon> higherTaxon;

        /**
         * Gets the value of the higherTaxon property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the higherTaxon property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getHigherTaxon().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link HigherTaxon }
         * 
         * 
         */
        public List<HigherTaxon> getHigherTaxon() {
            if (higherTaxon == null) {
                higherTaxon = new ArrayList<HigherTaxon>();
            }
            return this.higherTaxon;
        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;element name="Identifier" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}String255" maxOccurs="unbounded"/&gt;
     *       &lt;/sequence&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "identifier"
    })
    public static class Identifiers {

        @XmlElement(name = "Identifier", required = true)
        @XmlJavaTypeAdapter(NormalizedStringAdapter.class)
        @XmlSchemaType(name = "normalizedString")
        protected List<String> identifier;

        /**
         * Gets the value of the identifier property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the identifier property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getIdentifier().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link String }
         * 
         * 
         */
        public List<String> getIdentifier() {
            if (identifier == null) {
                identifier = new ArrayList<String>();
            }
            return this.identifier;
        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType&gt;
     *   &lt;complexContent&gt;
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType"&gt;
     *       &lt;sequence&gt;
     *         &lt;element name="Reference" type="{http://www.tdwg.org/schemas/abcd/3.0_zoology}Reference" maxOccurs="unbounded" minOccurs="0"/&gt;
     *       &lt;/sequence&gt;
     *     &lt;/restriction&gt;
     *   &lt;/complexContent&gt;
     * &lt;/complexType&gt;
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "reference"
    })
    public static class References {

        @XmlElement(name = "Reference")
        protected List<Reference> reference;

        /**
         * Gets the value of the reference property.
         * 
         * <p>
         * This accessor method returns a reference to the live list,
         * not a snapshot. Therefore any modification you make to the
         * returned list will be present inside the JAXB object.
         * This is why there is not a <CODE>set</CODE> method for the reference property.
         * 
         * <p>
         * For example, to add a new item, do as follows:
         * <pre>
         *    getReference().add(newItem);
         * </pre>
         * 
         * 
         * <p>
         * Objects of the following type(s) are allowed in the list
         * {@link Reference }
         * 
         * 
         */
        public List<Reference> getReference() {
            if (reference == null) {
                reference = new ArrayList<Reference>();
            }
            return this.reference;
        }

    }

}
